From f6f3fabdd381c0b230ced8b91eaf7392758fe5ae Mon Sep 17 00:00:00 2001
From: Prudhvi Yarlagadda <pyarlaga@codeaurora.org>
Date: Mon, 4 Feb 2019 13:02:07 +0530
Subject: [PATCH 10/14] TEMP: NOT FOR REVIEW: qcs405: Add BLSP4 instance in
 depthcharge for SPI

Add BLSP4 instance in depthcharge for SPI

Change-Id: Ica6b5974be64f1005d1695622d005545386a7129
Signed-off-by: Prudhvi Yarlagadda <pyarlaga@codeaurora.org>
---
 src/drivers/bus/spi/qcs405.c | 52 ++++++++++++++++++++++++++++++++++----------
 src/drivers/bus/spi/qcs405.h | 51 +++++++++++++++++++++++++++++++++++++++++--
 2 files changed, 89 insertions(+), 14 deletions(-)

diff --git a/src/drivers/bus/spi/qcs405.c b/src/drivers/bus/spi/qcs405.c
index 7da696e01dfc..4b2a2ecd0623 100644
--- a/src/drivers/bus/spi/qcs405.c
+++ b/src/drivers/bus/spi/qcs405.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2012, 2016 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2012, 2016, 2019 The Linux Foundation. All rights reserved.
  *
  * Copyright 2014 Google Inc.
  *
@@ -20,6 +20,7 @@
 #include "base/container_of.h"
 #include "qcs405.h"
 #include "drivers/storage/mtd/mtd.h"
+#include "drivers/timer/timer.h"
 
 static void write_force_cs(SpiOps *ops, int assert);
 
@@ -174,13 +175,11 @@ void spi_setup_slave(unsigned int bus, unsigned int cs,
 	ds->slave.cs	= cs;
 	ds->regs	= &spi_reg[bus];
 
-	/*
-	 * TODO(vbendeb):
-	 * hardcoded frequency and mode - we might need to find a way
-	 * to configure this
-	 */
 	ds->freq = 10000000;
-	ds->mode = SPI_MODE3;
+	if (bus == BLSP4_SPI)
+		ds->freq = 800000;
+	ds->mode = SPI_MODE0;
+//	ds->mode = SPI_MODE3;
 }
 
 /*
@@ -389,6 +388,7 @@ static int __blsp_spi_read(struct ipq_spi_slave *ds, u8 *data_buffer,
 	unsigned int fifo_count;
 	int ret = SUCCESS;
 	int state_config;
+	struct stopwatch sw;
 
 	/* Configure no of bytes to read */
 	state_config = config_spi_state(ds, SPI_RESET_STATE);
@@ -429,6 +429,18 @@ static int __blsp_spi_read(struct ipq_spi_slave *ds, u8 *data_buffer,
 		}
 	}
 
+	stopwatch_init_msecs_expire(&sw, 10);
+
+	do {
+		val = read32(ds->regs->qup_operational);
+		if (stopwatch_expired(&sw)) {
+			printf("Read timeout\n");
+			ret = -ETIMEDOUT;
+			goto out;
+		}
+
+	}while(!(val & MAX_INPUT_DONE_FLAG));
+
 out:
 	/*
 	 * Put the SPI Core back in the Reset State
@@ -449,8 +461,10 @@ static int blsp_spi_read(struct ipq_spi_slave *ds, u8 *data_buffer,
 		length = (bytes < MAX_COUNT_SIZE) ? bytes : MAX_COUNT_SIZE;
 
 		ret = __blsp_spi_read(ds, data_buffer, length);
-		if (ret != SUCCESS)
+		if (ret != SUCCESS){
+			printf("Read failed ret = %d\n",ret);
 			return ret;
+		}
 
 		data_buffer += length;
 		bytes -= length;
@@ -472,11 +486,14 @@ static int __blsp_spi_write(struct ipq_spi_slave *ds, const u8 *cmd_buffer,
 	unsigned int fifo_count;
 	int ret = SUCCESS;
 	int state_config;
+	struct stopwatch sw;
 
 	state_config = config_spi_state(ds, SPI_RESET_STATE);
 	if (state_config)
 		return state_config;
 
+	/* Configure input and output enable */
+	enable_io_config(ds, write_len, read_len);
 	/* No of bytes to be written in Output FIFO */
 	writel(bytes, ds->regs->qup_mx_output_count);
 	writel(bytes, ds->regs->qup_mx_input_count);
@@ -484,9 +501,6 @@ static int __blsp_spi_write(struct ipq_spi_slave *ds, const u8 *cmd_buffer,
 	if (state_config)
 		return state_config;
 
-	/* Configure input and output enable */
-	enable_io_config(ds, write_len, read_len);
-
 	/*
 	 * read_len considered to ensure that we read the dummy data for the
 	 * write we performed. This is needed to ensure with WR-RD transaction
@@ -547,6 +561,18 @@ static int __blsp_spi_write(struct ipq_spi_slave *ds, const u8 *cmd_buffer,
 		}
 	}
 
+	stopwatch_init_msecs_expire(&sw, 10);
+
+	do {
+		val = read32(ds->regs->qup_operational);
+		if (stopwatch_expired(&sw)) {
+			printf("Write timeout\n");
+			ret = -ETIMEDOUT;
+			goto out;
+		}
+
+	}while(!(val & MAX_OUTPUT_DONE_FLAG));
+
 out:
 	/*
 	 * Put the SPI Core back in the Reset State
@@ -566,8 +592,10 @@ static int blsp_spi_write(struct ipq_spi_slave *ds, u8 *cmd_buffer,
 		length = (bytes < MAX_COUNT_SIZE) ? bytes : MAX_COUNT_SIZE;
 
 		ret = __blsp_spi_write(ds, cmd_buffer, length);
-		if (ret != SUCCESS)
+		if (ret != SUCCESS) {
+			printf("Write failed ret = %d\n",ret);
 			return ret;
+		}
 
 		cmd_buffer += length;
 		bytes -= length;
diff --git a/src/drivers/bus/spi/qcs405.h b/src/drivers/bus/spi/qcs405.h
index c12e8b130e44..bd4d2ae7096a 100644
--- a/src/drivers/bus/spi/qcs405.h
+++ b/src/drivers/bus/spi/qcs405.h
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2012, 2016 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2012, 2016, 2019 The Linux Foundation. All rights reserved.
  * Copyright 2014 Google Inc.
  *
  * See file CREDITS for list of people who contributed to this
@@ -31,70 +31,91 @@
 #define QUP1_BASE	((unsigned char *)0x78b6000u)
 #define QUP2_BASE	((unsigned char *)0x78b7000u)
 #define QUP3_BASE	((unsigned char *)0x78b8000u)
+#define QUP4_BASE	((unsigned char *)0x78b9000u)
 
 #define BLSP_QUP0_REG_BASE		(QUP0_BASE + 0x00000000)
 #define BLSP_QUP1_REG_BASE		(QUP1_BASE + 0x00000000)
 #define BLSP_QUP2_REG_BASE		(QUP2_BASE + 0x00000000)
 #define BLSP_QUP3_REG_BASE		(QUP3_BASE + 0x00000000)
+#define BLSP_QUP4_REG_BASE		(QUP4_BASE + 0x00000000)
 
 #define BLSP0_SPI_CONFIG_REG		(BLSP_QUP0_REG_BASE + 0x00000300)
 #define BLSP1_SPI_CONFIG_REG		(BLSP_QUP1_REG_BASE + 0x00000300)
+#define BLSP4_SPI_CONFIG_REG		(BLSP_QUP4_REG_BASE + 0x00000300)
 #define BLSP5_SPI_CONFIG_REG		(BLSP_QUP0_REG_BASE + 0x00000300)
 
 #define BLSP0_SPI_IO_CONTROL_REG	(BLSP_QUP0_REG_BASE + 0x00000304)
 #define BLSP1_SPI_IO_CONTROL_REG	(BLSP_QUP1_REG_BASE + 0x00000304)
+#define BLSP4_SPI_IO_CONTROL_REG	(BLSP_QUP4_REG_BASE + 0x00000304)
 #define BLSP5_SPI_IO_CONTROL_REG	(BLSP_QUP0_REG_BASE + 0x00000304)
 
 #define BLSP0_SPI_ERROR_FLAGS_REG	(BLSP_QUP0_REG_BASE + 0x00000308)
 #define BLSP1_SPI_ERROR_FLAGS_REG	(BLSP_QUP1_REG_BASE + 0x00000308)
+#define BLSP4_SPI_ERROR_FLAGS_REG	(BLSP_QUP4_REG_BASE + 0x00000308)
 #define BLSP5_SPI_ERROR_FLAGS_REG	(BLSP_QUP0_REG_BASE + 0x00000308)
 
 #define BLSP0_SPI_DEASSERT_WAIT_REG	(BLSP_QUP0_REG_BASE + 0x00000310)
 #define BLSP1_SPI_DEASSERT_WAIT_REG	(BLSP_QUP1_REG_BASE + 0x00000310)
+#define BLSP4_SPI_DEASSERT_WAIT_REG	(BLSP_QUP4_REG_BASE + 0x00000310)
 #define BLSP5_SPI_DEASSERT_WAIT_REG	(BLSP_QUP0_REG_BASE + 0x00000310)
 #define BLSP0_SPI_ERROR_FLAGS_EN_REG	(BLSP_QUP0_REG_BASE + 0x0000030c)
 #define BLSP1_SPI_ERROR_FLAGS_EN_REG	(BLSP_QUP1_REG_BASE + 0x0000030c)
+#define BLSP4_SPI_ERROR_FLAGS_EN_REG	(BLSP_QUP4_REG_BASE + 0x0000030c)
 #define BLSP5_SPI_ERROR_FLAGS_EN_REG	(BLSP_QUP0_REG_BASE + 0x0000030c)
 
 #define BLSP_QUP0_CONFIG_REG		(BLSP_QUP0_REG_BASE + 0x00000000)
 #define BLSP_QUP1_CONFIG_REG		(BLSP_QUP1_REG_BASE + 0x00000000)
+#define BLSP_QUP4_CONFIG_REG		(BLSP_QUP4_REG_BASE + 0x00000000)
 
 #define BLSP_QUP0_ERROR_FLAGS_REG	(BLSP_QUP0_REG_BASE      + 0x0000001c)
 #define BLSP_QUP1_ERROR_FLAGS_REG	(BLSP_QUP1_REG_BASE      + 0x0000001c)
+#define BLSP_QUP4_ERROR_FLAGS_REG	(BLSP_QUP4_REG_BASE      + 0x0000001c)
 
 #define BLSP_QUP0_ERROR_FLAGS_EN_REG	(BLSP_QUP0_REG_BASE + 0x00000020)
 #define BLSP_QUP1_ERROR_FLAGS_EN_REG	(BLSP_QUP1_REG_BASE + 0x00000020)
+#define BLSP_QUP4_ERROR_FLAGS_EN_REG	(BLSP_QUP4_REG_BASE + 0x00000020)
 
 #define BLSP_QUP0_OPERATIONAL_MASK	(BLSP_QUP0_REG_BASE + 0x00000028)
 #define BLSP_QUP1_OPERATIONAL_MASK	(BLSP_QUP1_REG_BASE + 0x00000028)
+#define BLSP_QUP4_OPERATIONAL_MASK	(BLSP_QUP4_REG_BASE + 0x00000028)
 
 #define BLSP_QUP0_OPERATIONAL_REG	(BLSP_QUP0_REG_BASE + 0x00000018)
 #define BLSP_QUP1_OPERATIONAL_REG	(BLSP_QUP1_REG_BASE + 0x00000018)
+#define BLSP_QUP4_OPERATIONAL_REG	(BLSP_QUP4_REG_BASE + 0x00000018)
 
 #define BLSP_QUP0_IO_MODES_REG		(BLSP_QUP0_REG_BASE + 0x00000008)
 #define BLSP_QUP1_IO_MODES_REG		(BLSP_QUP1_REG_BASE + 0x00000008)
+#define BLSP_QUP4_IO_MODES_REG		(BLSP_QUP4_REG_BASE + 0x00000008)
 
 #define BLSP_QUP0_STATE_REG		(BLSP_QUP0_REG_BASE + 0x00000004)
 #define BLSP_QUP1_STATE_REG		(BLSP_QUP1_REG_BASE + 0x00000004)
+#define BLSP_QUP4_STATE_REG		(BLSP_QUP4_REG_BASE + 0x00000004)
 
 #define BLSP_QUP0_INPUT_FIFOc_REG(c) \
 		(BLSP_QUP0_REG_BASE + 0x00000218 + 4 * (c))
 #define BLSP_QUP1_INPUT_FIFOc_REG(c) \
 		(BLSP_QUP1_REG_BASE + 0x00000218 + 4 * (c))
+#define BLSP_QUP4_INPUT_FIFOc_REG(c) \
+		(BLSP_QUP4_REG_BASE + 0x00000218 + 4 * (c))
 
 #define BLSP_QUP0_OUTPUT_FIFOc_REG(c) \
 		(BLSP_QUP0_REG_BASE + 0x00000110 + 4 * (c))
 #define BLSP_QUP1_OUTPUT_FIFOc_REG(c) \
 		(BLSP_QUP1_REG_BASE + 0x00000110 + 4 * (c))
+#define BLSP_QUP4_OUTPUT_FIFOc_REG(c) \
+		(BLSP_QUP4_REG_BASE + 0x00000110 + 4 * (c))
 
 #define BLSP_QUP0_MX_INPUT_COUNT_REG	(BLSP_QUP0_REG_BASE + 0x00000200)
 #define BLSP_QUP1_MX_INPUT_COUNT_REG	(BLSP_QUP1_REG_BASE + 0x00000200)
+#define BLSP_QUP4_MX_INPUT_COUNT_REG	(BLSP_QUP4_REG_BASE + 0x00000200)
 
 #define BLSP_QUP0_MX_OUTPUT_COUNT_REG	(BLSP_QUP0_REG_BASE + 0x00000100)
 #define BLSP_QUP1_MX_OUTPUT_COUNT_REG	(BLSP_QUP1_REG_BASE + 0x00000100)
+#define BLSP_QUP4_MX_OUTPUT_COUNT_REG	(BLSP_QUP4_REG_BASE + 0x00000100)
 
 #define BLSP_QUP0_SW_RESET_REG		(BLSP_QUP0_REG_BASE + 0x0000000c)
 #define BLSP_QUP1_SW_RESET_REG		(BLSP_QUP1_REG_BASE + 0x0000000c)
+#define BLSP_QUP4_SW_RESET_REG		(BLSP_QUP4_REG_BASE + 0x0000000c)
 
 #define QUP_STATE_VALID_BIT			2
 #define QUP_STATE_VALID				1
@@ -137,6 +158,8 @@
 #define OUTPUT_SERVICE_FLAG			(1 << 8)
 #define INPUT_SERVICE_FLAG			(1 << 9)
 #define QUP_OUTPUT_FIFO_FULL			(1 << 6)
+#define MAX_OUTPUT_DONE_FLAG		(1<<10)
+#define MAX_INPUT_DONE_FLAG		(1<<11)
 #define SPI_INPUT_BLOCK_SIZE			4
 #define SPI_OUTPUT_BLOCK_SIZE			4
 #define MSM_QUP_MAX_FREQ			51200000
@@ -152,6 +175,7 @@
 #define SPI_MODE3				3
 #define BLSP0_SPI				0
 #define BLSP1_SPI				1
+#define BLSP4_SPI				4
 #define BLSP5_SPI				5
 
 struct blsp_spi {
@@ -220,7 +244,30 @@ static const struct blsp_spi spi_reg[] = {
 		0,
 		BLSP_QUP0_OPERATIONAL_MASK,
 		BLSP0_SPI_DEASSERT_WAIT_REG,
-	},{0},{0},{0},
+	},{0},{0},
+
+	/* BLSP4 registers for SPI interface */
+	{
+		BLSP4_SPI_CONFIG_REG,
+		BLSP4_SPI_IO_CONTROL_REG,
+		BLSP4_SPI_ERROR_FLAGS_REG,
+		BLSP4_SPI_ERROR_FLAGS_EN_REG,
+		BLSP_QUP4_CONFIG_REG,
+		BLSP_QUP4_ERROR_FLAGS_REG,
+		BLSP_QUP4_ERROR_FLAGS_EN_REG,
+		BLSP_QUP4_OPERATIONAL_REG,
+		BLSP_QUP4_IO_MODES_REG,
+		BLSP_QUP4_STATE_REG,
+		BLSP_QUP4_INPUT_FIFOc_REG(0),
+		BLSP_QUP4_OUTPUT_FIFOc_REG(0),
+		BLSP_QUP4_MX_INPUT_COUNT_REG,
+		BLSP_QUP4_MX_OUTPUT_COUNT_REG,
+		BLSP_QUP4_SW_RESET_REG,
+		0,
+		0,
+		BLSP_QUP4_OPERATIONAL_MASK,
+		BLSP4_SPI_DEASSERT_WAIT_REG,
+	},
 
 	/* BLSP5 registers for SPI interface */
 	{
-- 
The Qualcomm Innovation Center, Inc. is a member of the Code Aurora Forum,
a Linux Foundation Collaborative Project

